#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>

/*
    2010 - Copyright by Bee <http://www.honeybeenet.altervista.org>.
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

/*
    After a lot of super hard work, this application launcher is ready!!!
        and working!!!!!!!!!
*/

#define REQUIRED_ARGC 4
int main(int argc, char **argv)
{
    struct stat buf;
    char *command;
    char *commandline[] = {NULL,NULL,NULL};
    char *lockfile;
    int fd;
    int pid;
    int status;
    int dup2_return = 0;
    char syncfile[]="/tmp/gbeesu.XXXXXX";
    pid_t cpid;
    if(argc > REQUIRED_ARGC)
    {
        printf("DEBUG: Number of necessary args found.\n");
        command = argv[1];                               // 1, REQUIRED_ARGC - 3
        if(strcmp(command, "gedit-beesu-plugin") == 0)
        {
            printf("DEBUG: strcmp succeeded.\n");
            command        = argv[2];                    // 2, REQUIRED_ARGC - 2
            commandline[0] = argv[3];                    // 3, REQUIRED_ARGC - 1
            lockfile       = argv[4];                    // 4, REQUIRED_ARGC
            if(argc > (REQUIRED_ARGC + 1))
                printf("DEBUG: Appending additional args to commandline.\n");
                commandline[1] = argv[REQUIRED_ARGC + 1];// 5, REQUIRED_ARGC + 1
            if(lstat(lockfile, &buf) == 0)
            {
                printf("DEBUG: lstat on lockfile succeeded.\n");
                if(buf.st_size == 0 && S_ISREG(buf.st_mode))
                {
                    printf("DEBUG: buf checks passed.\n");
                    fd = mkstemp(syncfile);
                    printf("DEBUG: fd initialized.\n");
                    if(fd == -1) {
                        printf("DEBUG: fd failure, exiting.\n");
                        return EXIT_FAILURE;
                    }
                    printf("DEBUG: About to close fd.\n");
                    close(fd);
                    printf("DEBUG: fd closed, about to fork.\n");
                    pid = fork();
                    printf("DEBUG: Going into PID switch.\n");
                    switch(pid)
                    {
                        case 0:
                            printf("DEBUG: PID switch case 0.\n");
/*
                            fd = open("/dev/null", O_RDWR);
                            if(fd != -1)
                            {
                                printf("DEBUG: Opened fd for /dev/null.\n");
                                printf("DEBUG: Calling dup2 for 0\n");
                                dup2_return = dup2(fd, 0);
                                if(dup2_return < 0) {
                                    printf("DEBUG: dup2(fd, 0) failed with error %d.\n", dup2_return);
                                } else {
       	       	       	       	    printf("DEBUG: dup2(fd, 0) succeeded.\n");
                                }
                                printf("DEBUG: Calling dup2 for	1\n");
                                dup2_return = dup2(fd, 1);
                                if(dup2_return < 0) {
                                    printf("DEBUG: dup2(fd, 1) failed with error %d.\n", dup2_return);
                                    
                                } else {
       	       	       	       	    printf("DEBUG: dup2(fd, 1) succeeded.\n");
                                }
                                printf("DEBUG: Calling dup2 for	2\n");
                                dup2_return = dup2(fd, 2);
                                if(dup2_return < 0) {
                                    printf("DEBUG: dup2(fd, 2) failed with error %d.\n", dup2_return);
                                } else {
                                    printf("DEBUG: dup2(fd, 2) succeeded.\n");
                                }
                            }
                            printf("DEBUG: Closing fd for /dev/null.\n");
                            close(fd);
*/
                            printf("DEBUG: About to call signal(SIGHUP, SIG_IGN).\n");
                            signal(SIGHUP, SIG_IGN);
                            printf("DEBUG: Going into FORK switch.\n");
                            switch(fork()) // internal fork!!
                            {
                                case -1:
                                    printf("DEBUG: FORK switch case -1.\n");
                                    _exit(EXIT_FAILURE);
                                    break;
                                case 0:
                                    printf("DEBUG: FORK switch case 0.\n");
                                    signal(SIGHUP, SIG_IGN);
                                    unlink(syncfile);
                                    printf("DEBUG: About to execvp %s %s %s.\n", command, commandline[0], commandline[1]);
                                    if (execvp(command, commandline) < 0) {
                                       printf("DEBUG: execvp failed.\n");
                                    }
                                    _exit(EXIT_FAILURE);
                                    break;
                                default:
                                    printf("DEBUG: FORK switch default.\n");
                                    break;
                            }
                            _exit(EXIT_SUCCESS);
                            break;
                        case -1:
                            printf("DEBUG: PID switch case -1.\n");
                            unlink(syncfile);
                            return EXIT_FAILURE;
                            break;
                        default:
                            printf("DEBUG: PID switch case default.\n");
                            waitpid(pid, &status, 0);
                            // Wait (max 20 seconds!!!) for the syncfile to be removed!!!
                            printf("DEBUG: Waiting for the syncfile to be removed.\n");
                            for(status = 0; status < 20; status++)
                            {
                                if(access(syncfile, F_OK) == 0)
                                {
                                    sleep(1);
                                }
                                else
                                {
                                    break;
                                }
                            }
                            if(access(syncfile, F_OK) == 0)
                            {
                                printf("DEBUG: Syncfile error.\n");
                                // Enter here on error
                                unlink(syncfile);
                            }
                            else
                            {
                                printf("DEBUG: Syncfile success.\n");
                                // Enter here on success!!!!!!
                                printf("DEBUG: usleeping for 5000000, hope that is long enough for gedit to respawn.\n");
                                usleep(5000000);
                                unlink(lockfile);
                            }
                            printf("DEBUG: About to return SUCCESS.\n");
                            return EXIT_SUCCESS;
                            break;
                    }
                }
            }
        }
    }
    printf("DEBUG: About to return FAILURE.\n");
    return EXIT_FAILURE;
}

